src/Entity/Product.php
<?php

namespace App\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;

/**
 * @ORM\Entity(repositoryClass="App\Repository\ProductRepository")
 */
class Product
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @Groups({"product_details"})
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     * @Groups({"list_product","product_details"})
     */
    private $title;

    /**
     * @ORM\Column(type="float")
     * @Groups({"list_product","product_details"})
     */
    private $price;

    /**
     * @ORM\ManyToOne(targetEntity=Category::class, inversedBy="products")
     * @Groups({"product_details"})
     */
    private $Category;

    /**
     * @ORM\Column(type="integer", options={"default" : 0})
     * @Groups({"product_details"})
     */
    private $stock;

    /**
     * @ORM\Column(type="text", nullable=true)
     * @Groups({"product_details"})
     */
    private $description;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @Groups({"list_product"})
     */
    private $slug;

    /**
     * @ORM\OneToMany(targetEntity=Image::class, mappedBy="product")
     * @Groups({"list_product","product_details"})
     */
    private $images;

    /**
     * @ORM\ManyToMany(targetEntity=Panier::class, mappedBy="products")
     */
    private $paniers;


    public function __construct()
    {
        $this->images = new ArrayCollection();
        $this->paniers = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getPrice(): ?float
    {
        return $this->price;
    }

    public function setPrice(float $price): self
    {
        $this->price = $price;

        return $this;
    }

    public function getCategory(): ?Category
    {
        return $this->Category;
    }

    public function setCategory(?Category $Category): self
    {
        $this->Category = $Category;

        return $this;
    }

    public function getStock(): ?int
    {
        return $this->stock;
    }

    public function setStock(int $stock): self
    {
        $this->stock = $stock;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(?string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    /**
     * @return Collection<int, Image>
     */
    public function getImages(): Collection
    {
        return $this->images;
    }

    public function addImage(Image $image): self
    {
        if (!$this->images->contains($image)) {
            $this->images[] = $image;
            $image->setProduct($this);
        }

        return $this;
    }

    public function removeImage(Image $image): self
    {
        if ($this->images->removeElement($image)) {
            // set the owning side to null (unless already changed)
            if ($image->getProduct() === $this) {
                $image->setProduct(null);
            }
        }

        return $this;
    }

    /**
     * @return Collection<int, Panier>
     */
    public function getPaniers(): Collection
    {
        return $this->paniers;
    }

    public function addPanier(Panier $panier): self
    {
        if (!$this->paniers->contains($panier)) {
            $this->paniers[] = $panier;
            $panier->addProduct($this);
        }

        return $this;
    }

    public function removePanier(Panier $panier): self
    {
        if ($this->paniers->removeElement($panier)) {
            $panier->removeProduct($this);
        }

        return $this;
    }
}

src/Controller/Admin/AdminProductController.php
<?php

namespace App\Controller\Admin;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Form\ProductType;
use App\Entity\Product;
use App\Entity\Image;
use App\Repository\CategoryRepository;
use App\Repository\ProductRepository;
use App\Services\ImageService;
use Doctrine\ORM\EntityManagerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Component\Validator\Validator\ValidatorInterface;
use Symfony\Component\String\Slugger\AsciiSlugger;
use Symfony\Component\HttpFoundation\Request;
use Knp\Component\Pager\PaginatorInterface;

/**
 * Require ROLE_ADMIN for *every* controller method in this class.
 *
 * @IsGranted("ROLE_USER")
 */

class AdminProductController extends AbstractController
{
    /**
     * @Route("/admin/produits", name="admin_products")
     */
    public function index(Request $request, PaginatorInterface $paginator, ProductRepository $productRepository): Response
    {
        $QueryProducts = $productRepository->findtheLatestProducts();
        $products = $paginator->paginate(
            $QueryProducts, /* query NOT result */
            $request->query->getInt("page", 1),
            9
        );
        return $this->render('admin_product/list.html.twig', [
            'products' => $products,
        ]);
    }

    /**
     * @Route("/admin/produit/createOrEdit/{id}", name="product_createOrEdit")
     */
    public function createOrEdit($id, Request $request, EntityManagerInterface $em, ImageService $imageService, ValidatorInterface $validator): Response
    {
        $images_path = [];
        if ($id == 0) {
            $product = new Product();
        } else {
            $product = $em->getRepository(Product::class)->find($id);
            $images = $em->getRepository(Image::class)->findBy(['product' => $product->getId()]);
            foreach ($images as $image) {
                array_push($images_path, $image->getPath());
            }
            if (!$product) {
                throw $this->createNotFoundException(
                    'produit introuvable '
                );
            }
        }

        $form = $this->createForm(ProductType::class, $product);
        $form->handleRequest($request);

        $errors = $validator->validate($product);
        if (count($errors) > 0) {
            $this->addFlash(
                'danger',
                (string) $errors
            );
            return new Response((string) $errors, 400);
        }
        if ($form->isSubmitted() && $form->isValid()) {

            $images = $form['images']->getData();
            if ($images) {
                foreach ($images as $img) {
                    $image = new Image();
                    $newFilename = $imageService->uploadImage($img);
                    $image->setPath('images/' . $newFilename);
                    $image->setProduct($product);
                    $em->persist($image);
                }
            }
            $slugger = new AsciiSlugger();
            $slug = $slugger->slug($form['title']->getData());
            $product->setSlug($slug);

            $msg = 'Produit crée avec succès!';
            if ($product->getId() != 0) {
                $msg = 'Produit modifié avec succès!';
            } else {
                $productNumber = (int)$product->getCategory()->getProductNumber();
                $product->getCategory()->setProductNumber($productNumber + 1);
                $em->persist($product);
            }

            $this->addFlash(
                'notice',
                $msg
            );
        }
        $em->flush();

        //return $this->redirectToRoute('product_index');

        return $this->render('admin_product/createOrEdit.html.twig', [
            'form' => $form->createView(),
            'images_path' => $images_path
        ]);
    }

    /**
     * @Route("/admin/produit/remove/{id}", name="product_remove")
     */
    public function remove(Product $product,  EntityManagerInterface $em)
    {
        // TODO
        $em->remove($product);
        $products_numbers = $product->getCategory()->getProductNumber();
        $product->getCategory()->setProductNumber($products_numbers - 1);
        $em->flush();
        return $this->redirectToRoute('admin_products');
    }
}

templates/admin_product/createOrEdit.html.twig
{% extends 'admin_connected_base.html.twig' %}

{% block title %}Les produits
{% endblock %}

{% block body %}
<div class="container border border-success rounded p-4 ">
	<div class="bg-light p-3">
		<h3>
			{% set pr = app.request.attributes.get('id') %}
			{% if pr != 0 %}
				Modifier les caractéristiques de votre produit :
			{% else %}
				Creer un nouveau produit :
			{% endif %}
		</h3>
		<a href="{{ path('admin_products')}}" class="btn btn-primary mt-2 float-right">
			<i class="bi bi-arrow-return-left"></i>
			Retour à la liste des produits</a>
	</div>

	{{ form_start(form, {'action' : path('product_createOrEdit',{"id" : pr}), 'method': 'POST', 'attr' : {'class' : 'font-weight-bold'}}) }}
	{{ form_row(form.title) }}
	{% if images_path is not empty %}
		{{ form_row(form.images, {'label' : 'Ajouter d\'autre images','attr' : { 'accept' : 'image/*',
                    'multiple' : 'multiple', 'required' : false, 'class' : 'form-control mb-2'} }) }}
		  {% for image_path in images_path %}
		  <img  width = "100" height = "100" src="{{ asset(image_path)}}" alt=" image de {{ image_path}}" class="img-fluid"/>
	    {% endfor %}
		{% else %}
			{{ form_row(form.images,{'label' : 'Images','attr' : { 'accept' : 'image/*',
                    'multiple' : 'multiple', 'class' : 'form-control mb-2'} }) }}
		{% endif %}	
			{{ form_row(form.price) }}
			{{ form_row(form.Category) }}
			{{ form_row(form.stock) }}
			{{ form_row(form.description) }}
			<button class="btn btn-primary mt-3" type="submit">Enregistrer</button>
			{{ form_end(form) }}
		</div>
	{% endblock %}

templates/admin_product/list.html.twig
{% extends 'admin_connected_base.html.twig' %}

{% block title %}Liste des produits disponibles !
{% endblock %}

{% block body %}
	<div class="bg-light p-3">
		<h3>Liste des produits :
		</h3>
		<a class="btn btn-primary mt-2 mb-2 float-right" href="{{ path('product_createOrEdit', { id : 0 })}}">
			<i class="fas fa-plus fa-solid"></i>Ajouter
		</a>
	</div>
	<div class="ml-2 mt-2">
		<table class="table table-striped" style="color: #1d1e20;">
			<thead>
				<tr>
					<th scope="col" colspan="3">Titre</th>
					<th scope="col">Categorie</th>
					<th scope="col">Image</th>
					<th scope="col">Prix</th>
					<th scope="col">Quantité en stock</th>
					<th scope="col"></th>
					<th scope="col"></th>
					<th scope="col"></th>

				</tr>
			</thead>
			<tbody>
				{% for product in products %}
					<tr>
						<td colspan="3">{{product.title}}</td>
						<td>{{product.category.name}}</td>
						<td><img width="10%" height="20%" src="{{ asset(product.images[0].path) }}" alt=" photos du produit {{product.title}}"/></td>
						<td>{{ product.price}}</td>
						<td>{{product.stock}}</td>
						<td>
							<button onclick="showProduct('{{product.slug}}')" class=" btn btn-success">
								<i class="bi bi-binoculars"></i>
								Visulaiser
							</button>
						</td>
						<td>
							<a href="{{ path('product_createOrEdit', { 'id' : product.id } )}}" class=" btn btn-warning">
								<i class="bi bi-pencil-fill"></i>
								Modifier
							</a>
						</td>
						<td>
							<a href="{{ path('product_remove', { 'id' : product.id } )}}" class="btn btn-danger">
								<i class="bi bi-trash-fill"></i>
								Supprimer</a>
						</td>
					</tr>
				{% endfor %}
			</tbody>
		</table>
		<div class="navigation">
			{{ knp_pagination_render(products) }}
		</div>

	</div>
{% endblock %}